//index.js
import WxValidate from '../../utils/wxValidate';
//获取应用实例
const app = getApp();
Page({
  data: {
    form: {}
  },
  initValidate() {
    const rules = {
      phone: {
        required: true,
      },
      oldPwd: {
        required: true,
      },
      newPwd: {
        required: true,
      },
      isnewPwd: {
        required: false,
      },
    }
    // 验证字段的提示信息，若不传则调用默认的信息
    const messages = {
      phone: {
        required: '请输入手机号',
      },
      oldPwd: {
        required: '请输入原密码',
      },
      newPwd: {
        required: '请输入新密码',
      },
      isnewPwd: {
        required: '请输入确认密码'
      }
    };
    this.WxValidate = new WxValidate(rules, messages)
  },
  //事件处理函数
  formSubmit: function (e) {
    const params = e.detail.value;
    if (!this.WxValidate.checkForm(params)) {
      const error = this.WxValidate.errorList[0];
      wx.showToast({
        title: error.msg,
        icon: 'none',
        duration: 2000
      })
      return false
    } else {
      // 判断新密码，确认新密码是否一致
      if (params.newPwd === params.isnewPwd) {
        console.log(params);
      } else {
        wx.showToast({
          title: '新密码与确认密码不一致，请重新输入',
          icon: 'none',
          duration: 2000
        })
      }
    }
  },
  onLoad: function (options) {
    this.initValidate()//验证规则函数
  },
})
